
(* Sintaxe abstracta  para mini-Turtle

   Note : A sintaxe abstracta aqui descrita contm voluntariamente menos 
   construes do que a sintaxe concreta. Ser ento necessrio traduzir 
   algumas construes no momento da anlise sintctica (acar sintctico).
*)

(* expresses inteiras *)

type binop = Add | Sub | Mul | Div

type expr =
  | Econst of int
  | Evar   of string
  | Ebinop of binop * expr * expr

(* instrues *)

type stmt =
  | Spenup
  | Spendown
  | Sforward of expr
  | Sturn    of expr (* vira para a esquerda *)
  | Scolor   of Turtle.color
  | Sif      of expr * stmt * stmt
  | Srepeat  of expr * stmt
  | Sblock   of stmt list
  | Scall    of string * expr list

(* definio de procedimentos *)

type def = {
  name    : string;
  formals : string list; (* argumentos *)
  body    : stmt; }

(* programa *)

type program = {
  defs : def list;
  main : stmt; }



